#include "polymake/client.h"
#include "polymake/Map.h"
#include "polymake/Graph.h"
#include "polymake/IncidenceMatrix.h"
#include "polymake/polytope/kspans.h"
#include "polymake/graph/lattice_builder.h"

namespace polymake { namespace polytope {

   

   perl::Object compute_kspans(const Matrix<Rational>& lattice_points, int k, const Matrix<Rational>& additional_vertices) {
      YueClosureOperator<BasicDecoration> yueclosure(lattice_points.rows());
      KSpanCut<BasicDecoration> yuecut(lattice_points, additional_vertices, k);
      YueDecorator decorator(lattice_points.rows(), k);
     
      Lattice<BasicDecoration, Nonsequential> init_lattice;
      Lattice<BasicDecoration, Nonsequential> result = graph::lattice_builder::compute_lattice_from_closure<BasicDecoration>(
            yueclosure, yuecut, decorator, 1, graph::lattice_builder::Primal(), init_lattice);
      return result.makeObject();
   }

   UserFunction4perl("", &compute_kspans, "compute_kspans(Matrix $ Matrix)");

}}
